#include "ota_message.h"
#include "gd32f10x.h"
#include "w25q32.h"
#include "ec800m.h"
#include "usart.h"
#include "delay.h"
#include <stdio.h>

#define BufferSize 100		//ȡݿռ
static OTA_MESSAGE ota_message = {0};
void clear_ota_message_config_block(void);
void write_ota_message_to_flash(uint32_t *data, int size){
	uint8_t *pdata = (uint8_t *)data;
	W25Q32_PageWrite(pdata,256*OTA_EVENT_BLOCK);//дڵڶĵһҳ
}

/*
 *  save_ota_message_config_params(OTA_MESSAGE *params)
 *  
 *  
 *  ֵ
 *  ãota¼Ϣ
 */
int save_ota_message_config_params(OTA_MESSAGE *params)
{
		if(params == NULL)
				return -1;
		memset(&ota_message, 0, sizeof(OTA_MESSAGE));	
		memcpy(&ota_message, params, sizeof(OTA_MESSAGE)); 
	  clear_ota_message_config_block();
		write_ota_message_to_flash((uint32_t *)&ota_message,sizeof(OTA_MESSAGE));
		return 0;
}

// ģdownloadУֵ
static uint16_t checksum(const char *str, uint16_t len)
{
  uint16_t sum = 0;
  uint8_t odd = 0;

  // ַΪһַΪ8λ8λΪ0
  if (len % 2 == 1)
  {
    odd = 1;
    len--;
  }

  // ÿַΪһ16λֵ
  for (uint16_t i = 0; i < len; i += 2)
  {
    sum ^= ((uint16_t)str[i] << 8) | (uint16_t)str[i + 1];
  }

  // ַΪҪһַ0xFF00
  if (odd)
  {
    sum ^= (uint16_t)str[len] << 8;
  }
  // У
  return sum;
}

//strе
static char* find_string(char *strs, char *str, int len)
{
    int i = 0;
	char *start = NULL;
    while(i < len){
		start = strstr(strs, str);
        if(start != NULL){
            break;
        }
        i++;
        strs++;
    }
    if(i == len + 1){
        return NULL;
    }
    return start;
}


/*
 *  static void extract_data_from_buffer(const char* buffer, uint32_t *len_ptr, uint16_t *checkCode_ptr)
 *  bufferַ
 *  jsonЧַlen_ptr,checkCode_ptrУָ
 *  ֵ
 *  :eg.   QFDWL: 621,3e23  jsonϢȡjsonЧȺУ
 */
static void extract_data_from_buffer(char* buffer, uint32_t *len_ptr, uint16_t *checkCode_ptr)
{
  char *start = find_string(buffer, "+QFDWL:",BufferSize);
  if (start != NULL)
  {
    start += 8; // "+QFDWL:"
    uint32_t len = 0;
    sscanf(start, "%u,", &len);     // ȡ
    start = strchr(start, ',') + 1; // 
    uint16_t checkCode = 0;
    sscanf(start, "%hx", &checkCode); // ȡ16
    // ȡݴβ
    *len_ptr = len;
    *checkCode_ptr = checkCode;
  }
}

bool WaitForUpData(char* dmaBuffer)
{
	if (UART0_RX_STAT > 0)
  	{
		UART0_RX_STAT = 0;
		uint32_t len;
		uint16_t checkCode;
			char *temp;
		extract_data_from_buffer(dmaBuffer, &len, &checkCode);
		uint16_t jsonCheck = checksum(dmaBuffer, len);
		if (checkCode == jsonCheck)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

/*
 *  load_config_params(CONFIG_PARAMS *params)
 *  
 *  
 *  ֵota־ǷЧ 0Ч -1Ч
 *  ãw25q32мotaϢ
 */
int load_ota_message_config_params()
{
	//У
	char *dmabuffer=malloc(BufferSize);
	__LOAD_CONFIG:
	// get data from UFS
	dma_config_change(dmabuffer,BufferSize);
	Delay_Ms(1000);
	EC800MSendCmd(LOAD_otaMSG_FILE, strlen(LOAD_otaMSG_FILE)); //"AT+QFDWL=otaMSG.txt\r\n"
	Delay_Ms(1000);
	dma_config();
	if(WaitForUpData(dmabuffer) == false) goto __LOAD_CONFIG;
	// W25Q32_Read((uint8_t *)&ota_message, OTA_EVENT_BLOCK*64*1024, sizeof(OTA_MESSAGE)); //W25Q32жȡṹ
	// FLASH_Read(OTA_EVENT_START_ADDR,&ota_message,sizeof(OTA_MESSAGE));
	memset(&ota_message,0,sizeof(OTA_MESSAGE));
	memcpy((uint8_t*)&ota_message,dmabuffer,sizeof(OTA_MESSAGE));
	free(dmabuffer);
	if(ota_message.otaflag == 1U)
	{
		
		return 0;
	}
	else 
	{
		return -1;
	}
}
OTA_MESSAGE *get_config_params()
{
		return &ota_message;
}
/*
 *  void clear_ota_message_config_block(void)
 *  
 *  
 *  ֵ
 *  ãblockڰota¼Ϣ
 */
void clear_ota_message_config_block(void)
{
	static OTA_MESSAGE ota_message = {0};
	ota_message.otaflag = 1;
	ota_message.XmodemByte = 200 * 1024;
	
	EC800MSendCmd(OPEN_otaMSG_FILE,strlen(OPEN_otaMSG_FILE));
	if(WaitResponse("QFOPEN:", 2000) == 0)
		return;

	EC800MSendCmd(WRITE_otaMSG_FILE,strlen(WRITE_otaMSG_FILE));
	if(WaitResponse("CONNECT", 2000))
		return;

	EC800MSendCmd((uint8_t *)&ota_message,sizeof(OTA_MESSAGE));
	if(WaitResponse("QFWRITE", 5000))
		return;

	EC800MSendCmd(CLOSE_otaMSG_FILE,strlen(CLOSE_otaMSG_FILE));
	if(WaitResponse("OK", 2000))
		return;

	// EC800MSendCmd("AT+QFDEL=\"UFS:otaMSG.txt\r\n\"",27);	//ɾļ
}
